<?php
/**
 * Invision Power Services
 * IP.Board v3.0.1
 * 123flashchat Public
 *
 * @author 		$Author: TopCMM $
 * @copyright	(c) 2001 - 2010 TopCMM, Inc.
 * @license		http://www.invisionpower.com/community/board/license.html
 * @package		Invision Power Board
 * @subpackage	123flashchat
 * @link		http://www.123flashchat.com
 */

if ( ! defined( 'IN_IPB' ) )
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
	exit();
}

class public_123flashchat_123flashchat_123flashchat extends ipsCommand
{
	/**
	 * Temporary HTML output
	 *
	 * @access	private
	 * @var		string
	 */
	private $output				= "";

	/**
	 * Page title
	 *
	 * @access	private
	 * @var		string
	 */
	private $page_title			= "";


	/**
	 * Class entry point
	 *
	 * @access	public
	 * @param	object		Registry reference
	 * @return	void		[Outputs to screen/redirects]
	 */
	public function doExecute( ipsRegistry $registry ){
		/* Make sure the calednar is installed and enabled */
		if( ! IPSLib::appIsInstalled( '123flashchat' ) ){
			$this->registry->output->showError( 'no_permission', 1076 );
		}
		
		/* Load language  */
		$this->registry->class_localization->loadLanguageFile( array( 'public_123flashchat' ) );

		/* Page Title */
		if( $this->page_title == "" ){
			$this->page_title = $this->settings['board_name'] . " " . $this->lang->words['page_title'];
		}
		$fcsetting = $this->get_fc_config();
		if($fcsetting['fc_fullscreen'] == 1){
			$fcsetting['fc_client_width'] = '100%';
			$fcsetting['fc_client_height'] = '100%';
		}
		$this->output .= $this->registry->output->getTemplate('123flashchat')->chat($this->fc_get_chat_url($fcsetting),$fcsetting);
		$this->registry->output->addContent( $this->output );		
		$this->registry->output->setTitle( $this->page_title );
		$this->registry->output->addNavigation( $this->lang->words['page_title'], 'app=123flashchat&module=123flashchat',"false",'123flashchat' );
		$this->registry->output->addNavigation( $this->lang->words['page_title'].' Room', 'app=123flashchat&module=123flashchat&section=123flashchat',"false",'123flashchat' );
		/* Output */
		if($fcsetting['fc_fullscreen'] == 1){
			echo $this->output;	//full screen
		}else{			
			$this->registry->output->sendOutput();//emed
		}
	}

	function fc_get_chat_url($fcsetting){		
		switch($fcsetting['fc_extendserver']){
			case 0:
				if($fcsetting['fc_client_mode'] == 1){
					$clientname = '123flashchat.swf';
				}else{
					$clientname = 'htmlchat/123flashchat.html';
				}
				$url =  $fcsetting['fc_client_loc'] . $clientname . "?init_host=" . $fcsetting['fc_server_host'] . "&init_port=" . $fcsetting['fc_server_port'] ;
				$url .= ($fcsetting['fc_server_host_s'] ? "&init_host_s=" . $fcsetting['fc_server_host_s'] : "") . ($fcsetting['fc_server_port_s'] ? "&init_port_s=" . $fcsetting['fc_server_port_s'] : "");
				$url .= ($fcsetting['fc_server_host_h'] ? "&init_host_h=" . $fcsetting['fc_server_host_h'] : "") . ($fcsetting['fc_server_port_h'] ? "&init_port_h=" . $fcsetting['fc_server_port_h'] : "");
				break;
			case 1:
				if($fcsetting['fc_client_mode'] == 1){
					$clientname = '123flashchat.swf';
				}else{
					$clientname = 'htmlchat/123flashchat.html';
				}
				$url = $fcsetting['fc_client_loc'] . $clientname . "?init_host=" . $fcsetting['fc_server_host'] . "&init_port=" . $fcsetting['fc_server_port'];
				$url .= ($fcsetting['fc_server_host_s'] ? "&init_host_s=" . $fcsetting['fc_server_host_s'] : "") . ($fcsetting['fc_server_port_s'] ? "&init_port_s=" . $fcsetting['fc_server_port_s'] : "");
				$url .= ($fcsetting['fc_server_host_h'] ? "&init_host_h=" . $fcsetting['fc_server_host_h'] : "") . ($fcsetting['fc_server_port_h'] ? "&init_port_h=" . $fcsetting['fc_server_port_h'] : "");
				$url .= "&init_group=" . $fcsetting['fc_group'];
				break;
			case 2:
				$url = "http://free.123flashchat.com/js.php?room=" . urlencode($fcsetting['fc_room']) . "&skin="  . $fcsetting['fc_client_skin'] . "&lang="  . $fcsetting['fc_client_lang'];
				return $url;
				break;
		}
		if ($this->memberData['member_id']){
			if(!empty($this->memberData['name']) && !empty($this->memberData['members_pass_hash']) ){
				$url .= "&init_user=" . rawurlencode(htmlspecialchars_decode($this->memberData['name'])) . "&init_password=" . $this->memberData['members_pass_hash'];
			}
		}
		if ($this->request['room']){
			$url .= "&init_room=" . $this->request['room'];
		}
		return $url;		
	}
	
	public function get_fc_config(){
		$this->DB->build( array( 'select' => '*',
			'from'   => '123flashchat',
			'where'  => "id=1")
		);
		$this->DB->execute();
		$result = $this->DB->fetch();
		return $result;
	}

}
